# clear memory
rm(list=ls())

sink("IV.out", append=FALSE, split=TRUE)

# load data from csv file
X=read.csv("card_Data.csv")

#rm(card_Data)

# save data as R dataset
save(X,file="card_Data.RData")



# Summary of the data
summary(X)

#prepare data
X$lwage=log(X$wage)
X$exp=1976-X$birthyear-X$educ
X$exp2=X$exp^2

# OLS estimate
cov(X$lwage,X$educ)
var(X$educ)
cov(X$lwage,X$educ)/var(X$educ)

ols1=lm(lwage ~ educ, X)
summary(ols1)
ols2=lm(lwage ~ educ + exp + exp2 + black + south + smsa, X)
summary(ols2)

# IV estimates
C=cov(cbind(X$lwage,X$educ,X$nearc4))
C[1,3]/C[2,3]

# install.packages("AER")
library(AER)

iv1=ivreg(lwage ~ educ | nearc4, data=X)
summary(iv1)
iv2=ivreg(lwage ~ educ + exp + exp2 + black + south + smsa | nearc4 + exp + exp2 + black + south + smsa, data=X)
summary(iv2)

# estimate IV manually
fs1=lm(educ ~ nearc4, data=X)
summary(fs1)
educ_hat=fitted.values(fs1)
tsls1=lm(lwage ~ educ_hat, X)
summary(tsls1)

fs2=lm(educ ~ nearc4 + exp + exp2 + black + south + smsa , data=X)
summary(fs2)
educ_hat=fitted.values(fs2)
summary(fs2)
tsls2=lm(lwage ~ educ_hat + exp + exp2 + black + south + smsa, X)
summary(tsls2)

# close sink
sink()
